version: '3.8'
networks:
 kong-net:
   name: kong-net
   driver: bridge
services:
  postgres:
    image: 'postgres:9.6'
    container_name: kong-database
    networks:
      - kong-net
    ports:
      - '5432:5432'
    environment:
      - POSTGRES_USER=kong
      - POSTGRES_DB=kong
      - POSTGRES_PASSWORD=kongpass
    healthcheck:
      test: ["CMD", "pg_isready", "-U", "kong"]
      interval: 5s
      timeout: 5s
      retries: 5
  kong-migration:
    image: kong/kong-gateway:2.8.1.4-alpine
    command: 'kong migrations bootstrap'
    networks:
      - kong-net
    environment:
      - KONG_DATABASE=postgres
      - KONG_PG_HOST=kong-database
      - KONG_PG_PASSWORD=kongpass
    depends_on:
      - postgres
  kong-gateway:
    image: 'kong/kong-gateway:2.8.1.4-alpine'
    container_name: kong-gateway
    networks:
      - kong-net
    depends_on:
      - kong-migration
    environment:
      - 'KONG_DATABASE=postgres'
      - 'KONG_PG_HOST=kong-database'
      - 'KONG_PG_USER=kong'
      - 'KONG_PG_PASSWORD=kongpass'
      - 'KONG_PROXY_ACCESS_LOG=/dev/stdout'
      - 'KONG_ADMIN_ACCESS_LOG=/dev/stdout'
      - 'KONG_PROXY_ERROR_LOG=/dev/stderr'
      - 'KONG_ADMIN_ERROR_LOG=/dev/stderr'
      - 'KONG_ADMIN_LISTEN=0.0.0.0:8001'
    ports:
      - '8000:8000'
      - '8443:8443'
      - '8001:8001'
      - '8002:8002'
    
  #######################################
  # Konga database prepare
  #######################################
  konga-prepare:
    container_name: konga-prepare
    image: pantsel/konga
    command: "-c prepare -a postgres -u postgresql://kong:kongpass@kong-database:5432/konga_db"
    networks:
      - kong-net
    restart: on-failure
    links:
      - postgres
    depends_on:
      - postgres
 #######################################
  # Konga: Kong GUI
  #######################################
  konga:
    container_name: konga
    image: pantsel/konga
    restart: unless-stopped
    networks:
      - kong-net
    environment:
      DB_ADAPTER: postgres
      DB_HOST: kong-database
      DB_USER: kong
      DB_PASSWORD: kongpass
      DB_DATABASE: konga_db
      # any string will OK for token
      TOKEN_SECRET: iu7YDcPLiZkozQXzZ9kka3Ee1Vid5ZgQ
      NODE_ENV: production
    depends_on:
      - konga-prepare
    ports:
      - "1111:1337"